#include <dpp/dpp.h>
#include "listeners/ready.h"
#include "listeners/slash.h"
#include "api/config.h"

#define CONFIG_PATH "config.json"

using json = nlohmann::json;

using namespace dpp;

int main(int argc, char **argv) {
    json configuration = config::read_config(argc < 2 ? CONFIG_PATH : argv[1]);

    cluster bot(configuration["token"], dpp::i_default_intents | dpp::i_message_content);

    bot.on_slashcommand([&bot](const slashcommand_t &event) { slash::execute(bot, event); });

    bot.on_ready([&bot](const ready_t &event) { ready::execute(bot, event); });

    bot.start(dpp::st_wait);

    return 0;
}